<?xml version="1.0" encoding="UTF-8"?>
<!--
  LEGAL INFORMATION
  
  Copyright (c) 2007 Syncro Soft Ltd  (http://www.oxygenxml.com)
  All rights reserved.
  
  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are
  met:
  
  * Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer. 
  Altered source versions must be plainly marked as such, and must not be 
  misrepresented as being the original software.
  
  * Redistributions in binary form must reproduce the above copyright
  notice, this list of conditions and the following disclaimer in
  the documentation and/or other materials provided with the
  distribution.
  
  * Neither the name of the Syncro Soft nor
  the names of its contributors may be used to endorse or promote
  products derived from this software without specific prior written
  permission.
  
  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR
  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:n="http://www.oxygenxml.com/nvdl" version="2.0">

  <xsl:function name="n:matches" as="xs:boolean" xmlns:xs="http://www.w3.org/2001/XMLSchema">
    <xsl:param name="uri"/>
    <xsl:param name="ns"/>
    <xsl:param name="wildcard"/>
    <xsl:choose>
      <xsl:when test="$wildcard='' or not(contains($ns, $wildcard))">
        <xsl:value-of select="$uri=$ns"/>
      </xsl:when>
      <xsl:when test="starts-with($ns, $wildcard)">
        <xsl:value-of select="n:matchLax($uri, substring-after($ns, $wildcard), $wildcard)"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:variable name="constant" select="substring-before($ns, $wildcard)"/>
        <xsl:choose>
          <xsl:when test="starts-with($uri, $constant)">
            <xsl:value-of
              select="n:matchLax(substring-after($uri, $constant), substring-after($ns, $wildcard), $wildcard)"
            />
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="false()"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:function>

  <xsl:function name="n:matchLax" as="xs:boolean" xmlns:xs="http://www.w3.org/2001/XMLSchema">
    <xsl:param name="uri"/>
    <xsl:param name="ns"/>
    <xsl:param name="wildcard"/>
    <xsl:choose>
      <xsl:when test="$ns=''">
        <xsl:value-of select="true()"/>
      </xsl:when>
      <xsl:when test="not(contains($ns, $wildcard))">
        <xsl:value-of select="ends-with($uri, $ns)"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:variable name="constant" select="substring-before($ns, $wildcard)"/>
        <xsl:value-of
          select="
            if 
            (contains($uri, $constant)) 
            then 
            n:matchLax(substring-after($uri, $constant), substring-after($ns, $wildcard), $wildcard) 
            else 
            false()
            "
        />
      </xsl:otherwise>
    </xsl:choose>
  </xsl:function>
</xsl:stylesheet>
