package com.oxygenxml.validate.nvdl.util;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Properties;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

/**
 * Checks if the root category from the log4j.properties is configured. If it is
 * not, the root category is put on the error level.
 *
 *
 * @author mircea
 * @created Feb 18, 2003
 * 
 */
public class Log4jChecker {

  /**
   * Checks if the root category from the log4j.properties is configured. If it is
   * not, the root category is put on the error level.
   * 
   */
  public static void checkLog4j() {
    Logger logger = Logger.getRootLogger();
    Enumeration appenders = logger.getAllAppenders();
    if (appenders == null || !appenders.hasMoreElements()) {
      String propertyString =
        "log4j.rootCategory=error, R\n"
          + "log4j.appender.R=org.apache.log4j.ConsoleAppender\n"
          + "log4j.appender.R.layout=org.apache.log4j.PatternLayout\n"
          + "log4j.appender.R.layout.ConversionPattern=%d{HH:mm:ss,SSS} %r %p [ %t ] %c - %m%n";

      Properties properties = new Properties();
      try {
        properties.load(new ByteArrayInputStream(propertyString.getBytes("UTF8")));
      } catch (IOException ioe) {
        ioe.printStackTrace();
      }
      PropertyConfigurator.configure(properties);
    }
  }

}
